Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 951)
+++ src/mlx/gui/gui.py	(revision 1010)
@@ -1,8 +1,8 @@
 # -*- coding: utf-8 -*-
 
-from statusicon import StatusIcon
-from statusbar import Statusbar
-from info import FlightInfo
-from update import Updater
+from .statusicon import StatusIcon
+from .statusbar import Statusbar
+from .info import FlightInfo
+from .update import Updater
 from mlx.gui.common import *
 from mlx.gui.flight import Wizard
@@ -18,5 +18,5 @@
 from mlx.gui.acars import ACARS
 from mlx.gui.timetable import TimetableWindow
-import cef
+from . import cef
 
 import mlx.const as const
@@ -51,17 +51,17 @@
 class GUI(fs.ConnectionListener):
     """The main GUI class."""
-    _authors = [ (u"Váradi", u"István", "prog_test"),
-                 (u"Galyassy", u"Tamás", "negotiation"),
-                 (u"Kurják", u"Ákos", "test"),
-                 (u"Nagy", u"Dániel", "test"),
-                 (u"Radó", u"Iván", "test"),
-                 (u"Petrovszki", u"Gábor", "test"),
-                 (u"Serfőző", u"Tamás", "test"),
-                 (u"Szebenyi", u"Bálint", "test"),
-                 (u"Zsebényi-Loksa", u"Gergely", "test") ]
+    _authors = [ ("Váradi", "István", "prog_test"),
+                 ("Galyassy", "Tamás", "negotiation"),
+                 ("Kurják", "Ákos", "test"),
+                 ("Nagy", "Dániel", "test"),
+                 ("Radó", "Iván", "test"),
+                 ("Petrovszki", "Gábor", "test"),
+                 ("Serfőző", "Tamás", "test"),
+                 ("Szebenyi", "Bálint", "test"),
+                 ("Zsebényi-Loksa", "Gergely", "test") ]
 
     def __init__(self, programDirectory, config):
         """Construct the GUI."""
-        gobject.threads_init()
+        GObject.threads_init()
 
         self._programDirectory = programDirectory
@@ -108,5 +108,7 @@
         """Build the GUI."""
 
-        self._mainWindow = window = gtk.Window()
+        self._mainWindow = window = Gtk.Window()
+        if os.name!="nt":
+            window.set_visual(window.get_screen().lookup_visual(0x21))
         window.set_title(WINDOW_TITLE_BASE)
         window.set_icon_from_file(os.path.join(iconDirectory, "logo.ico"))
@@ -116,9 +118,9 @@
         if os.name=="nt":
             window.connect("leave-notify-event", self._handleLeaveNotify)
-        accelGroup = gtk.AccelGroup()
+        accelGroup = Gtk.AccelGroup()
         window.add_accel_group(accelGroup)
         window.realize()
 
-        mainVBox = gtk.VBox()
+        mainVBox = Gtk.VBox()
         window.add(mainVBox)
 
@@ -135,9 +137,9 @@
         mainVBox.pack_start(menuBar, False, False, 0)
 
-        self._notebook = gtk.Notebook()
+        self._notebook = Gtk.Notebook()
         mainVBox.pack_start(self._notebook, True, True, 4)
 
         self._wizard = Wizard(self)
-        label = gtk.Label(xstr("tab_flight"))
+        label = Gtk.Label(xstr("tab_flight"))
         label.set_use_underline(True)
         label.set_tooltip_text(xstr("tab_flight_tooltip"))
@@ -145,5 +147,5 @@
 
         self._flightInfo = FlightInfo(self)
-        label = gtk.Label(xstr("tab_flight_info"))
+        label = Gtk.Label(xstr("tab_flight_info"))
         label.set_use_underline(True)
         label.set_tooltip_text(xstr("tab_flight_info_tooltip"))
@@ -152,5 +154,5 @@
 
         self._weightHelp = WeightHelp(self)
-        label = gtk.Label(xstr("tab_weight_help"))
+        label = Gtk.Label(xstr("tab_weight_help"))
         label.set_use_underline(True)
         label.set_tooltip_text(xstr("tab_weight_help_tooltip"))
@@ -159,5 +161,5 @@
         (logWidget, self._logView)  = self._buildLogWidget()
         addFaultTag(self._logView.get_buffer())
-        label = gtk.Label(xstr("tab_log"))
+        label = Gtk.Label(xstr("tab_log"))
         label.set_use_underline(True)
         label.set_tooltip_text(xstr("tab_log_tooltip"))
@@ -165,5 +167,5 @@
 
         self._fleetGateStatus = FleetGateStatus(self)
-        label = gtk.Label(xstr("tab_gates"))
+        label = Gtk.Label(xstr("tab_gates"))
         label.set_use_underline(True)
         label.set_tooltip_text(xstr("tab_gates_tooltip"))
@@ -171,5 +173,5 @@
 
         self._acars = ACARS(self)
-        label = gtk.Label("ACARS")
+        label = Gtk.Label("ACARS")
         label.set_use_underline(True)
         self._notebook.append_page(self._acars, label)
@@ -178,5 +180,5 @@
         self._debugLogWidget.show_all()
 
-        mainVBox.pack_start(gtk.HSeparator(), False, False, 0)
+        mainVBox.pack_start(Gtk.HSeparator(), False, False, 0)
 
         self._statusbar = Statusbar(iconDirectory)
@@ -197,6 +199,4 @@
 
         window.show_all()
-        if os.name=="nt":
-            window.get_window().focus()
 
         self._wizard.grabDefault()
@@ -206,6 +206,5 @@
         self._statusIcon = StatusIcon(iconDirectory, self)
 
-        self._busyCursor = gdk.Cursor(gdk.CursorType.WATCH if pygobject
-                                      else gdk.WATCH)
+        self._busyCursor = Gdk.Cursor(Gdk.CursorType.WATCH)
 
         self._loadPIREPDialog = None
@@ -361,5 +360,5 @@
     def takeoffAntiIceOn(self, value):
         """Set the anti-ice on indicator."""
-        gobject.idle_add(self._setTakeoffAntiIceOn, value)
+        GObject.idle_add(self._setTakeoffAntiIceOn, value)
 
     @property
@@ -401,5 +400,5 @@
     def landingAntiIceOn(self, value):
         """Set the anti-ice on indicator."""
-        gobject.idle_add(self._setLandingAntiIceOn, value)
+        GObject.idle_add(self._setLandingAntiIceOn, value)
 
     @property
@@ -444,10 +443,9 @@
         return self._flightInfo.faultsFullyExplained
 
-    if pygobject:
-        @property
-        def backgroundColour(self):
-            """Get the background colour of the main window."""
-            return self._mainWindow.get_style_context().\
-              get_background_color(gtk.StateFlags.NORMAL)
+    @property
+    def backgroundColour(self):
+        """Get the background colour of the main window."""
+        return self._mainWindow.get_style_context().\
+            get_background_color(Gtk.StateFlags.NORMAL)
 
     def run(self):
@@ -463,5 +461,5 @@
 
         singleton.raiseCallback = self.raiseCallback
-        gtk.main()
+        Gtk.main()
         singleton.raiseCallback = None
 
@@ -472,5 +470,5 @@
     def updateDone(self):
         """Called when the update is done (and there is no need to restart)."""
-        gobject.idle_add(self._updateDone)
+        GObject.idle_add(self._updateDone)
 
     def connected(self, fsType, descriptor):
@@ -481,5 +479,5 @@
         fs.sendMessage(const.MESSAGETYPE_INFORMATION,
                        "Welcome to MAVA Logger X " + const.VERSION)
-        gobject.idle_add(self._handleConnected, fsType, descriptor)
+        GObject.idle_add(self._handleConnected, fsType, descriptor)
 
     def _handleConnected(self, fsType, descriptor):
@@ -496,5 +494,5 @@
         """Called when the connection failed."""
         self._logger.untimedMessage("Connection to the simulator failed")
-        gobject.idle_add(self._connectionFailed)
+        GObject.idle_add(self._connectionFailed)
 
     def _connectionFailed(self):
@@ -503,6 +501,6 @@
         self._statusbar.updateConnection(self._connecting, self._connected)
 
-        dialog = gtk.MessageDialog(parent = self._mainWindow,
-                                   type = MESSAGETYPE_ERROR,
+        dialog = Gtk.MessageDialog(parent = self._mainWindow,
+                                   type = Gtk.MessageType.ERROR,
                                    message_format = xstr("conn_failed"))
 
@@ -529,5 +527,5 @@
             self._flight.disconnected()
 
-        gobject.idle_add(self._disconnected)
+        GObject.idle_add(self._disconnected)
 
     def _disconnected(self):
@@ -535,5 +533,5 @@
         self._statusbar.updateConnection(self._connecting, self._connected)
 
-        dialog = gtk.MessageDialog(type = MESSAGETYPE_ERROR,
+        dialog = Gtk.MessageDialog(type = Gtk.MessageType.ERROR,
                                    message_format = xstr("conn_broken"),
                                    parent = self._mainWindow)
@@ -574,5 +572,5 @@
     def _bookFlightsCallback(self, returned, result):
         """Called when the booking of flights has finished."""
-        gobject.idle_add(self._handleBookFlightsResult, returned, result)
+        GObject.idle_add(self._handleBookFlightsResult, returned, result)
 
     def _handleBookFlightsResult(self, returned, result):
@@ -593,10 +591,10 @@
     def cancelFlight(self):
         """Cancel the current file, if the user confirms it."""
-        dialog = gtk.MessageDialog(parent = self._mainWindow,
-                                   type = MESSAGETYPE_QUESTION,
+        dialog = Gtk.MessageDialog(parent = self._mainWindow,
+                                   type = Gtk.MessageType.QUESTION,
                                    message_format = xstr("cancelFlight_question"))
 
-        dialog.add_button(xstr("button_no"), RESPONSETYPE_NO)
-        dialog.add_button(xstr("button_yes"), RESPONSETYPE_YES)
+        dialog.add_button(xstr("button_no"), Gtk.ResponseType.NO)
+        dialog.add_button(xstr("button_yes"), Gtk.ResponseType.YES)
 
         dialog.set_title(WINDOW_TITLE_BASE)
@@ -604,5 +602,5 @@
         dialog.hide()
 
-        if result==RESPONSETYPE_YES:
+        if result==Gtk.ResponseType.YES:
             self.reset()
 
@@ -655,5 +653,5 @@
     def insertFlightLogLine(self, index, timestampString, text, isFault):
         """Insert the flight log line with the given data."""
-        gobject.idle_add(self._insertFlightLogLine, index,
+        GObject.idle_add(self._insertFlightLogLine, index,
                          formatFlightLogLine(timestampString, text),
                          isFault)
@@ -670,19 +668,19 @@
     def removeFlightLogLine(self, index):
         """Remove the flight log line with the given index."""
-        gobject.idle_add(self._removeFlightLogLine, index)
+        GObject.idle_add(self._removeFlightLogLine, index)
 
     def addFault(self, id, timestampString, text):
         """Add a fault to the list of faults."""
         faultText = formatFlightLogLine(timestampString, text).strip()
-        gobject.idle_add(self._flightInfo.addFault, id, faultText)
+        GObject.idle_add(self._flightInfo.addFault, id, faultText)
 
     def updateFault(self, id, timestampString, text):
         """Update a fault in the list of faults."""
         faultText = formatFlightLogLine(timestampString, text).strip()
-        gobject.idle_add(self._flightInfo.updateFault, id, faultText)
+        GObject.idle_add(self._flightInfo.updateFault, id, faultText)
 
     def clearFault(self, id):
         """Clear a fault in the list of faults."""
-        gobject.idle_add(self._flightInfo.clearFault, id)
+        GObject.idle_add(self._flightInfo.clearFault, id)
 
     def _removeFlightLogLine(self, index):
@@ -696,6 +694,6 @@
     def check(self, flight, aircraft, logger, oldState, state):
         """Update the data."""
-        gobject.idle_add(self._monitorWindow.setData, state)
-        gobject.idle_add(self._statusbar.updateTime, state.timestamp)
+        GObject.idle_add(self._monitorWindow.setData, state)
+        GObject.idle_add(self._statusbar.updateTime, state.timestamp)
 
     def resetFlightStatus(self):
@@ -707,5 +705,5 @@
     def setStage(self, stage):
         """Set the stage of the flight."""
-        gobject.idle_add(self._setStage, stage)
+        GObject.idle_add(self._setStage, stage)
 
     def _setStage(self, stage):
@@ -723,5 +721,5 @@
     def setRating(self, rating):
         """Set the rating of the flight."""
-        gobject.idle_add(self._setRating, rating)
+        GObject.idle_add(self._setRating, rating)
 
     def _setRating(self, rating):
@@ -732,5 +730,5 @@
     def setNoGo(self, reason):
         """Set the rating of the flight to No-Go with the given reason."""
-        gobject.idle_add(self._setNoGo, reason)
+        GObject.idle_add(self._setNoGo, reason)
 
     def _setNoGo(self, reason):
@@ -741,19 +739,14 @@
     def _handleMainWindowState(self, window, event):
         """Hande a change in the state of the window"""
-        iconified = gdk.WindowState.ICONIFIED if pygobject \
-                    else gdk.WINDOW_STATE_ICONIFIED
-
-        if (event.changed_mask&WINDOW_STATE_WITHDRAWN)!=0:
-            if (event.new_window_state&WINDOW_STATE_WITHDRAWN)!=0:
+        iconified = Gdk.WindowState.ICONIFIED
+
+        if (event.changed_mask&Gdk.WindowState.WITHDRAWN)!=0:
+            if (event.new_window_state&Gdk.WindowState.WITHDRAWN)!=0:
                 self._statusIcon.mainWindowHidden()
             else:
                 self._statusIcon.mainWindowShown()
 
-        if self.config.hideMinimizedWindow and not pygobject and \
-           (event.changed_mask&WINDOW_STATE_ICONIFIED)!=0 and \
-           (event.new_window_state&WINDOW_STATE_ICONIFIED)!=0:
-            self.hideMainWindow(savePosition = False)
-        elif (event.changed_mask&WINDOW_STATE_ICONIFIED)!=0 and \
-             (event.new_window_state&WINDOW_STATE_ICONIFIED)==0:
+        if (event.changed_mask&Gdk.WindowState.ICONIFIED)!=0 and \
+           (event.new_window_state&Gdk.WindowState.ICONIFIED)==0:
             self._mainWindow.present()
 
@@ -763,9 +756,9 @@
         Here we reset the focus to the main window as CEF might have acquired
         it earlier."""
-        self._mainWindow.get_window().focus()
+        self._mainWindow.get_window().focus(0)
 
     def raiseCallback(self):
         """Callback for the singleton handling code."""
-        gobject.idle_add(self.raiseMainWindow)
+        GObject.idle_add(self.raiseMainWindow)
 
     def raiseMainWindow(self):
@@ -798,8 +791,5 @@
             self._mainWindow.move(self._mainWindowX, self._mainWindowY)
 
-        if pygobject:
-            self._mainWindow.show()
-        else:
-            self._mainWindow.present()
+        self._mainWindow.show()
         self._mainWindow.deiconify()
 
@@ -858,5 +848,5 @@
             self._stdioText += text
 
-        gobject.idle_add(self._writeStdIO)
+        GObject.idle_add(self._writeStdIO)
 
     def beginBusy(self, message):
@@ -885,5 +875,5 @@
     def getFleetAsync(self, callback = None, force = None):
         """Get the fleet asynchronously."""
-        gobject.idle_add(self.getFleet, callback, force)
+        GObject.idle_add(self.getFleet, callback, force)
 
     def getFleet(self, callback = None, force = False, busyCallback = None):
@@ -920,5 +910,5 @@
             self._wizard.updateRTO()
         else:
-            gobject.idle_add(self.updateRTO, True)
+            GObject.idle_add(self.updateRTO, True)
 
     def rtoToggled(self, indicated):
@@ -928,5 +918,5 @@
     def _fleetResultCallback(self, returned, result):
         """Called when the fleet has been queried."""
-        gobject.idle_add(self._handleFleetResult, returned, result)
+        GObject.idle_add(self._handleFleetResult, returned, result)
 
     def _handleFleetResult(self, returned, result):
@@ -940,8 +930,8 @@
             self._fleet = None
 
-            dialog = gtk.MessageDialog(parent = self.mainWindow,
-                                       type = MESSAGETYPE_ERROR,
+            dialog = Gtk.MessageDialog(parent = self.mainWindow,
+                                       type = Gtk.MessageType.ERROR,
                                        message_format = xstr("fleet_failed"))
-            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+            dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.run()
@@ -971,5 +961,5 @@
     def _updatePlaneResultCallback(self, returned, result):
         """Called when the status of a plane has been updated."""
-        gobject.idle_add(self._handleUpdatePlaneResult, returned, result)
+        GObject.idle_add(self._handleUpdatePlaneResult, returned, result)
 
     def _handleUpdatePlaneResult(self, returned, result):
@@ -985,8 +975,8 @@
                     self._fleetGateStatus.handleFleet(self._fleet)
         else:
-            dialog = gtk.MessageDialog(parent = self.mainWindow,
-                                       type = MESSAGETYPE_ERROR,
+            dialog = Gtk.MessageDialog(parent = self.mainWindow,
+                                       type = Gtk.MessageType.ERROR,
                                        message_format = xstr("fleet_update_failed"))
-            dialog.add_button(xstr("button_ok"), RESPONSETYPE_ACCEPT)
+            dialog.add_button(xstr("button_ok"), Gtk.ResponseType.ACCEPT)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.run()
@@ -1075,43 +1065,46 @@
     def _buildMenuBar(self, accelGroup):
         """Build the main menu bar."""
-        menuBar = gtk.MenuBar()
-
-        fileMenuItem = gtk.MenuItem(xstr("menu_file"))
-        fileMenu = gtk.Menu()
+        menuBar = Gtk.MenuBar()
+
+        fileMenuItem = Gtk.MenuItem(xstr("menu_file"))
+        fileMenu = Gtk.Menu()
         fileMenuItem.set_submenu(fileMenu)
         menuBar.append(fileMenuItem)
 
-        loadPIREPMenuItem = gtk.ImageMenuItem(gtk.STOCK_OPEN)
+        loadPIREPMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_OPEN)
         loadPIREPMenuItem.set_use_stock(True)
         loadPIREPMenuItem.set_label(xstr("menu_file_loadPIREP"))
         loadPIREPMenuItem.add_accelerator("activate", accelGroup,
                                           ord(xstr("menu_file_loadPIREP_key")),
-                                          CONTROL_MASK, ACCEL_VISIBLE)
+                                          Gdk.ModifierType.CONTROL_MASK,
+                                          Gtk.AccelFlags.VISIBLE)
         loadPIREPMenuItem.connect("activate", self._loadPIREP)
         fileMenu.append(loadPIREPMenuItem)
 
-        fileMenu.append(gtk.SeparatorMenuItem())
-
-        quitMenuItem = gtk.ImageMenuItem(gtk.STOCK_QUIT)
+        fileMenu.append(Gtk.SeparatorMenuItem())
+
+        quitMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_QUIT)
         quitMenuItem.set_use_stock(True)
         quitMenuItem.set_label(xstr("menu_file_quit"))
         quitMenuItem.add_accelerator("activate", accelGroup,
                                      ord(xstr("menu_file_quit_key")),
-                                     CONTROL_MASK, ACCEL_VISIBLE)
+                                     Gdk.ModifierType.CONTROL_MASK,
+                                     Gtk.AccelFlags.VISIBLE)
         quitMenuItem.connect("activate", self._quit)
         fileMenu.append(quitMenuItem)
 
-        toolsMenuItem = gtk.MenuItem(xstr("menu_tools"))
-        toolsMenu = gtk.Menu()
+        toolsMenuItem = Gtk.MenuItem(xstr("menu_tools"))
+        toolsMenu = Gtk.Menu()
         toolsMenuItem.set_submenu(toolsMenu)
         menuBar.append(toolsMenuItem)
 
         self._timetableMenuItem = timetableMenuItem = \
-          gtk.ImageMenuItem(gtk.STOCK_INDENT)
+          Gtk.ImageMenuItem(Gtk.STOCK_INDENT)
         timetableMenuItem.set_use_stock(True)
         timetableMenuItem.set_label(xstr("menu_tools_timetable"))
         timetableMenuItem.add_accelerator("activate", accelGroup,
                                           ord(xstr("menu_tools_timetable_key")),
-                                          CONTROL_MASK, ACCEL_VISIBLE)
+                                          Gdk.ModifierType.CONTROL_MASK,
+                                          Gtk.AccelFlags.VISIBLE)
         timetableMenuItem.connect("activate", self.showTimetable)
         self._timetableMenuItem.set_sensitive(False)
@@ -1119,58 +1112,63 @@
 
         self._flightsMenuItem = flightsMenuItem = \
-          gtk.ImageMenuItem(gtk.STOCK_SPELL_CHECK)
+          Gtk.ImageMenuItem(Gtk.STOCK_SPELL_CHECK)
         flightsMenuItem.set_use_stock(True)
         flightsMenuItem.set_label(xstr("menu_tools_flights"))
         flightsMenuItem.add_accelerator("activate", accelGroup,
                                         ord(xstr("menu_tools_flights_key")),
-                                        CONTROL_MASK, ACCEL_VISIBLE)
+                                        Gdk.ModifierType.CONTROL_MASK,
+                                        Gtk.AccelFlags.VISIBLE)
         flightsMenuItem.connect("activate", self.showFlights)
         self._flightsMenuItem.set_sensitive(False)
         toolsMenu.append(flightsMenuItem)
 
-        checklistMenuItem = gtk.ImageMenuItem(gtk.STOCK_APPLY)
+        checklistMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_APPLY)
         checklistMenuItem.set_use_stock(True)
         checklistMenuItem.set_label(xstr("menu_tools_chklst"))
         checklistMenuItem.add_accelerator("activate", accelGroup,
                                           ord(xstr("menu_tools_chklst_key")),
-                                          CONTROL_MASK, ACCEL_VISIBLE)
+                                          Gdk.ModifierType.CONTROL_MASK,
+                                          Gtk.AccelFlags.VISIBLE)
         checklistMenuItem.connect("activate", self._editChecklist)
         toolsMenu.append(checklistMenuItem)
 
-        approachCalloutsMenuItem = gtk.ImageMenuItem(gtk.STOCK_EDIT)
+        approachCalloutsMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_EDIT)
         approachCalloutsMenuItem.set_use_stock(True)
         approachCalloutsMenuItem.set_label(xstr("menu_tools_callouts"))
         approachCalloutsMenuItem.add_accelerator("activate", accelGroup,
                                                  ord(xstr("menu_tools_callouts_key")),
-                                                 CONTROL_MASK, ACCEL_VISIBLE)
+                                                 Gdk.ModifierType.CONTROL_MASK,
+                                                 Gtk.AccelFlags.VISIBLE)
         approachCalloutsMenuItem.connect("activate", self._editApproachCallouts)
         toolsMenu.append(approachCalloutsMenuItem)
 
-        prefsMenuItem = gtk.ImageMenuItem(gtk.STOCK_PREFERENCES)
+        prefsMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_PREFERENCES)
         prefsMenuItem.set_use_stock(True)
         prefsMenuItem.set_label(xstr("menu_tools_prefs"))
         prefsMenuItem.add_accelerator("activate", accelGroup,
                                       ord(xstr("menu_tools_prefs_key")),
-                                      CONTROL_MASK, ACCEL_VISIBLE)
+                                      Gdk.ModifierType.CONTROL_MASK,
+                                      Gtk.AccelFlags.VISIBLE)
         prefsMenuItem.connect("activate", self._editPreferences)
         toolsMenu.append(prefsMenuItem)
 
-        toolsMenu.append(gtk.SeparatorMenuItem())
-
-        bugReportMenuItem = gtk.ImageMenuItem(gtk.STOCK_PASTE)
+        toolsMenu.append(Gtk.SeparatorMenuItem())
+
+        bugReportMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_PASTE)
         bugReportMenuItem.set_use_stock(True)
         bugReportMenuItem.set_label(xstr("menu_tools_bugreport"))
         bugReportMenuItem.add_accelerator("activate", accelGroup,
                                           ord(xstr("menu_tools_bugreport_key")),
-                                          CONTROL_MASK, ACCEL_VISIBLE)
+                                          Gdk.ModifierType.CONTROL_MASK,
+                                          Gtk.AccelFlags.VISIBLE)
         bugReportMenuItem.connect("activate", self._reportBug)
         toolsMenu.append(bugReportMenuItem)
 
-        viewMenuItem = gtk.MenuItem(xstr("menu_view"))
-        viewMenu = gtk.Menu()
+        viewMenuItem = Gtk.MenuItem(xstr("menu_view"))
+        viewMenu = Gtk.Menu()
         viewMenuItem.set_submenu(viewMenu)
         menuBar.append(viewMenuItem)
 
-        self._showMonitorMenuItem = gtk.CheckMenuItem()
+        self._showMonitorMenuItem = Gtk.CheckMenuItem()
         self._showMonitorMenuItem.set_label(xstr("menu_view_monitor"))
         self._showMonitorMenuItem.set_use_underline(True)
@@ -1178,9 +1176,10 @@
         self._showMonitorMenuItem.add_accelerator("activate", accelGroup,
                                                   ord(xstr("menu_view_monitor_key")),
-                                                  CONTROL_MASK, ACCEL_VISIBLE)
+                                                  Gdk.ModifierType.CONTROL_MASK,
+                                                  Gtk.AccelFlags.VISIBLE)
         self._showMonitorMenuItem.connect("toggled", self._toggleMonitorWindow)
         viewMenu.append(self._showMonitorMenuItem)
 
-        showDebugMenuItem = gtk.CheckMenuItem()
+        showDebugMenuItem = Gtk.CheckMenuItem()
         showDebugMenuItem.set_label(xstr("menu_view_debug"))
         showDebugMenuItem.set_use_underline(True)
@@ -1188,30 +1187,33 @@
         showDebugMenuItem.add_accelerator("activate", accelGroup,
                                           ord(xstr("menu_view_debug_key")),
-                                          CONTROL_MASK, ACCEL_VISIBLE)
+                                          Gdk.ModifierType.CONTROL_MASK,
+                                          Gtk.AccelFlags.VISIBLE)
         showDebugMenuItem.connect("toggled", self._toggleDebugLog)
         viewMenu.append(showDebugMenuItem)
 
-        helpMenuItem = gtk.MenuItem(xstr("menu_help"))
-        helpMenu = gtk.Menu()
+        helpMenuItem = Gtk.MenuItem(xstr("menu_help"))
+        helpMenu = Gtk.Menu()
         helpMenuItem.set_submenu(helpMenu)
         menuBar.append(helpMenuItem)
 
-        manualMenuItem = gtk.ImageMenuItem(gtk.STOCK_HELP)
+        manualMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_HELP)
         manualMenuItem.set_use_stock(True)
         manualMenuItem.set_label(xstr("menu_help_manual"))
         manualMenuItem.add_accelerator("activate", accelGroup,
                                        ord(xstr("menu_help_manual_key")),
-                                       CONTROL_MASK, ACCEL_VISIBLE)
+                                       Gdk.ModifierType.CONTROL_MASK,
+                                       Gtk.AccelFlags.VISIBLE)
         manualMenuItem.connect("activate", self._showManual)
         helpMenu.append(manualMenuItem)
 
-        helpMenu.append(gtk.SeparatorMenuItem())
-
-        aboutMenuItem = gtk.ImageMenuItem(gtk.STOCK_ABOUT)
+        helpMenu.append(Gtk.SeparatorMenuItem())
+
+        aboutMenuItem = Gtk.ImageMenuItem(Gtk.STOCK_ABOUT)
         aboutMenuItem.set_use_stock(True)
         aboutMenuItem.set_label(xstr("menu_help_about"))
         aboutMenuItem.add_accelerator("activate", accelGroup,
                                       ord(xstr("menu_help_about_key")),
-                                      CONTROL_MASK, ACCEL_VISIBLE)
+                                      Gdk.ModifierType.CONTROL_MASK,
+                                      Gtk.AccelFlags.VISIBLE)
         aboutMenuItem.connect("activate", self._showAbout)
         helpMenu.append(aboutMenuItem)
@@ -1222,5 +1224,5 @@
         """Toggle the debug log."""
         if menuItem.get_active():
-            label = gtk.Label(xstr("tab_debug_log"))
+            label = Gtk.Label(xstr("tab_debug_log"))
             label.set_use_underline(True)
             label.set_tooltip_text(xstr("tab_debug_log_tooltip"))
@@ -1232,23 +1234,20 @@
     def _buildLogWidget(self):
         """Build the widget for the log."""
-        alignment = gtk.Alignment(xscale = 1.0, yscale = 1.0)
+        alignment = Gtk.Alignment(xscale = 1.0, yscale = 1.0)
 
         alignment.set_padding(padding_top = 8, padding_bottom = 8,
                               padding_left = 16, padding_right = 16)
 
-        logScroller = gtk.ScrolledWindow()
+        logScroller = Gtk.ScrolledWindow()
         # FIXME: these should be constants in common
-        logScroller.set_policy(gtk.PolicyType.AUTOMATIC if pygobject
-                               else gtk.POLICY_AUTOMATIC,
-                               gtk.PolicyType.AUTOMATIC if pygobject
-                               else gtk.POLICY_AUTOMATIC)
-        logScroller.set_shadow_type(gtk.ShadowType.IN if pygobject
-                                    else gtk.SHADOW_IN)
-        logView = gtk.TextView()
+        logScroller.set_policy(Gtk.PolicyType.AUTOMATIC,
+                               Gtk.PolicyType.AUTOMATIC)
+        logScroller.set_shadow_type(Gtk.ShadowType.IN)
+        logView = Gtk.TextView()
         logView.set_editable(False)
         logView.set_cursor_visible(False)
         logScroller.add(logView)
 
-        logBox = gtk.VBox()
+        logBox = Gtk.VBox()
         logBox.pack_start(logScroller, True, True, 0)
         logBox.set_size_request(-1, 200)
@@ -1267,12 +1266,12 @@
         """Quit from the application."""
         if force:
-            result=RESPONSETYPE_YES
-        else:
-            dialog = gtk.MessageDialog(parent = self._mainWindow,
-                                       type = MESSAGETYPE_QUESTION,
+            result=Gtk.ResponseType.YES
+        else:
+            dialog = Gtk.MessageDialog(parent = self._mainWindow,
+                                       type = Gtk.MessageType.QUESTION,
                                        message_format = xstr("quit_question"))
 
-            dialog.add_button(xstr("button_no"), RESPONSETYPE_NO)
-            dialog.add_button(xstr("button_yes"), RESPONSETYPE_YES)
+            dialog.add_button(xstr("button_no"), Gtk.ResponseType.NO)
+            dialog.add_button(xstr("button_yes"), Gtk.ResponseType.YES)
 
             dialog.set_title(WINDOW_TITLE_BASE)
@@ -1280,12 +1279,12 @@
             dialog.hide()
 
-        if result==RESPONSETYPE_YES:
+        if result==Gtk.ResponseType.YES:
             self._statusIcon.destroy()
-            return gtk.main_quit()
+            return Gtk.main_quit()
 
     def _notebookPageSwitch(self, notebook, page, page_num):
         """Called when the current page of the notebook has changed."""
         if page_num==0:
-            gobject.idle_add(self._wizard.grabDefault)
+            GObject.idle_add(self._wizard.grabDefault)
         else:
             self._mainWindow.set_default(None)
@@ -1323,5 +1322,5 @@
     def _timetableCallback(self, returned, result):
         """Called when the timetable has been received."""
-        gobject.idle_add(self._handleTimetable, returned, result)
+        GObject.idle_add(self._handleTimetable, returned, result)
 
     def _handleTimetable(self, returned, result):
@@ -1336,8 +1335,8 @@
             self._timetableWindow.show_all()
         else:
-            dialog = gtk.MessageDialog(parent = self.mainWindow,
-                                       type = MESSAGETYPE_ERROR,
+            dialog = Gtk.MessageDialog(parent = self.mainWindow,
+                                       type = Gtk.MessageType.ERROR,
                                        message_format = xstr("timetable_failed"))
-            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+            dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.run()
@@ -1355,5 +1354,5 @@
     def _acceptedFlightsCallback(self, returned, result):
         """Called when the accepted flights have been received."""
-        gobject.idle_add(self._handleAcceptedFlights, returned, result)
+        GObject.idle_add(self._handleAcceptedFlights, returned, result)
 
     def _handleAcceptedFlights(self, returned, result):
